<template>
  <div data-view="single-user">
    <layout-single-frame>
      <template slot="content">
        <EditUserForm
          :user="user"
          :is-cleared="false"
          :is-loading="isLoading"
          :on-submit="$ability.can('update', 'user') ? updateUser : undefined"
        />
      </template>
    </layout-single-frame>
  </div>
</template>

<script>
  import EditUserForm from '../../components/forms/user/Edit';

  // TODO: Translate component

  export default {
    components: {
      EditUserForm
    },
    data() {
      return {
        user: {},
        isLoading: false
      };
    },
    created() {
      const { id } = this.$route.params;
      this.getUser(id);
    },
    methods: {
      getUser(id) {
        const query = { id };

        this.isLoading = true;
        this.$store.dispatch('users/getItem', query)
          .then((res) => {
            this.user = this.$store.getters['users/activeItem'];
            this.isLoading = false;
            return res;
          })
          .catch((err) => {
            this.isLoading = false;
            return err;
          });
      },
      updateUser(user) {
        const nextUser = {
          ...user,
          id: this.user.id
        };

        this.isLoading = true;

        return this.$store.dispatch('users/update', nextUser)
          .then((res) => {
            this.isLoading = false;
            this.user = this.$store.getters['users/activeItem'];

            return res;
          })
          .catch((err) => {
            this.isLoading = false;
            return err;
          });
      }
    },
    metaInfo() {
      return {
        title: 'User Details'
      };
    }
  };
</script>
